/**************************** Drpcscan_Main **********************************
* Purpose: This is the main function for for drpcscan                        *
* Author: DrekHead  (drekhead@arena.cwnet.com)  	                     *
* Revisions: v.021 Basic Design						     *
*	     v.022 BIG/LITTLE Endian Support				     *
*	     v.024 setjmp Host timeout alarm feature			     *
*	     v.031 Minor BugFixes					     *
* To do: 								     *
*	1. Add NIS Guessing/Map transfer (similar to YPX)                    *
*	2. display user out put for such services as rwhod		     *
*	3. NFS Export Display						     *
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "drpcscan.h"

int main(int argc,char *argv[])
{
	struct in_addr startip,stopip;	/* Start/Stop ip addr structs */
	u_long startnum,stopnum;

	printf("DRPCscan by: DrekHead v.%s\n",DRPCSCAN_VERSION);

	if(argc < 2)
	{
		printf("Usage: %s starting_ip [stopping_ip]\n",argv[0]);
		exit(-1);
	}
	startip.s_addr=inet_addr(argv[1]); /* Set startip variable */

	if(argc == 2)			/* If no stopip variable */
		stopip.s_addr=startip.s_addr;
	else
		stopip.s_addr=inet_addr(argv[2]);	/* Set to startip */

#ifdef LITTLE_ENDIAN			/* Determine Byte ordering */
	startnum=ntohl(startip.s_addr);
	stopnum=ntohl(stopip.s_addr);
#else					/* Default to BIG */
	startnum=startip.s_addr;
	stopnum=stopip.s_addr;
#endif
	
	signal(SIGALRM,drpc_alarm);	/* Set alarm handler */

	printf("Scanning from: %s to %s for RPC Services\n\n",argv[1],inet_ntoa(stopip));

	while(startnum <= stopnum)
	{
	hostip=(char *)inet_ntoa(startip);	/* Get Ascii string for ip */

	if(setjmp(bailout)==0)
		drpc_scan(hostip);		/* Call scanning function */
	else
	{
		printf("Timeout.\n");
		signal(SIGALRM,drpc_alarm);	/* Reset alarm handler */
	}
	startnum++;			/* Next IP */
	scanned++;			/* Up the counter */
#ifdef LITTLE_ENDIAN
	startip.s_addr=htonl(startnum);
#else
	startip.s_addr=startnum;
#endif
	}
	drpc_done();
        exit(0);
}

void drpc_alarm(int sig)
{
	longjmp(bailout,1);
}

void drpc_done(void)
{
	printf("\n\nScanned: %d hosts.\n",scanned);
	return;
}
