/*************************** Drpc_scan function ******************************
* Purpose: provide the primary scanning function to drpcscan                 *
* Author: DrekHead  (drekhead@arena.cwnet.com)				     *
* Revisions: See drpc_main.c						     *
* To Do: See drpc_main.c						     *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <rpc/rpc.h>

#define NOVER ((u_long)0)	/* No version number definition */

				/* Locally define the rpcent struct for fun */
struct rpcent {
        char    *r_name;        /* name of server for this rpc program */
        char    **r_aliases;    /* alias list */
        int     r_number;       /* rpc program number */
};

		
struct rpcent *getrpcent();	/* This func too! */

void drpc_scan(char *host)
{
	CLIENT *rpclient;	/* RPC Client Struct */
	struct rpcent *rpcinfo;	/* RPC entry Struct */

	printf("%s: ",host);
	setrpcent(0);
	while((rpcinfo=getrpcent(NULL)) != NULL)
	{
		alarm(2);
		if((rpclient=clnt_create(host,rpcinfo->r_number,NOVER,"tcp")))
		{
			printf("%s ",rpcinfo->r_name);
			clnt_destroy(rpclient);
		}
		alarm(0);
	}
	printf("\n");
	endrpcent();
	
	return;
}
